#!/usr/bin/python3.7
#
# DisplayName = assignRoleAndCreateTasks
# Arguments = Arg1
# Arg1.Type = String
# Arg1.Name = JobID

# This script is used to assign specific user set in metadata to specific role. Then duraation are set to tasks with planning API

import requests
import sys
import json

# VARS
ES = 'http://localhost:8080'
URL =  ES + "/Esprit/public/Interface/rpc"
USERNAME = "admin"
PASSWORD = "admin"
jobID = sys.argv[1]

SOURCESTEP = "CampaignProduction"
DESTSTEP = "WaitingCampaignValidation"


def esLogin():
    JSON = {"id":"1","method":"admin.login"}
    rLogin = requests.post( url=URL, json=JSON, auth=(USERNAME,PASSWORD) )
    cookies = rLogin.cookies
    cc = cookies.get_dict()
    return cc

def esLogout(cookie):
    JSON = {"id":"1","method":"admin.logout"}
    rLogout = requests.post( url=URL, json=JSON, cookies=cookie )
    print(rLogout.content)


def sendCall(JSON,cookie, ret):
    print(JSON)
    rSendCall = requests.post(url = URL, json= JSON, cookies=cookie)
    callData = rSendCall.json()
    print(callData)
    if ret:
       return callData[0]['result']
    else:
       return 'a'

cookie = esLogin()

GETMETADATA = [
    {
        "id": 2,
        "method": "metadata.getObjectMetadata",
        "params":{
            "ID":jobID,
            "class":"Job"
        }
    }
]

rGetDesginer = sendCall(GETMETADATA,cookie, True)
# print(rGetDesginer)
operatorBanner = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'AnnimatedBannerTaskUser']
timeBanner = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'BannerTime']
operatorPoster = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'PosterTaskUser']
timePoster = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'PosterTime']
operatorThreeD = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'ThreeDTaskUser']
timeThreeD = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'ThreeDTime']
operatorVideo = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'VideoTaskUser']
timeVideo = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'VideoTime']
operatorWebSite = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'WebsiteTaskUser']
timeWebsite = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'WebSiteTime']
operatorFlyer = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'FlyerTaskUser']
timeFlyer = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'FlyerTime']
operatorCatalog = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'CatalogTaskUser']
timeCatalog = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'CatalogTime']
operatorPhoto = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'PhotoTaskUser']
timePhoto = [metadata[2] for metadata in rGetDesginer['metadatas'] if metadata[1] == 'PhotoTime']


removetasks = [] 
delayTasks = [] 
roles = [] 
if len(operatorBanner) > 0:
      roles.append({"user": operatorBanner[0],"role": "GRAPHICARTIST"})
      time = float(timeBanner[0]) * 8 * 60 
      delayTasks.append(["BannerProduction",time])

if len(operatorPoster) > 0:
      roles.append({"user": operatorPoster[0],"role": "RETOUCHER"})
      time = float(timePoster[0]) * 8 * 60 
      delayTasks.append(["PosterProduction",time])

if len(operatorThreeD) > 0:
      roles.append({"user": operatorThreeD[0],"role": "DESIGNER"})
      time = float(timeThreeD[0]) * 8 * 60 
      delayTasks.append(["ThreeDProduction",time])

if len(operatorVideo) > 0:
      roles.append({"user": operatorVideo[0],"role": "SCENARIO"})
      time = float(timeVideo[0]) * 8 * 60 
      delayTasks.append(["VideoProduction",time])

if len(operatorWebSite) > 0:
      roles.append({"user": operatorWebSite[0],"role": "SOCIALMEDIAMANAGER"})
      time = float(timeWebsite[0]) * 8 * 60 
      delayTasks.append(["WebSiteProduction",time])

if len(operatorFlyer) > 0:
      roles.append({"user": operatorFlyer[0],"role": "ART_DIRECTOR"})
      time = float(timeFlyer[0]) * 8 * 60 
      delayTasks.append(["FlyerProduction",time])

if len(operatorCatalog) > 0:
      roles.append({"user": operatorCatalog[0],"role": "MARKETING"})
      time = float(timeCatalog[0]) * 8 * 60 
      delayTasks.append(["CatalogProduction",time])

if len(operatorPhoto) > 0:
      roles.append({"user": operatorPhoto[0],"role": "PHOTOGRAPHER"})
      time = float(timePhoto[0]) * 8 * 60 
      delayTasks.append(["PhotosProduction",time])

original_stdout = sys.stdout


for taskname in delayTasks:
        UPDATEDURATIONTASKS = [{"id": 2,"method": "planning.changeTaskDuration",
        "params":{
        "ID":jobID,
        "class":"Job",
        "name":taskname[0],
        "duration":taskname[1]
        }
        }]
        rRemovetasks = sendCall(UPDATEDURATIONTASKS,cookie, False)
        print(rRemovetasks)

        ADDRIGHTSTOJOB = [
          {
            "id": 2,
            "method": "job.edit",
            "params":{
            "ID":jobID,
            "roles": roles
             }
          }
        ]
        rAddJobRights = sendCall(ADDRIGHTSTOJOB,cookie,False)

esLogout(cookie)