import requests 
import sys
import json


# This script is used to get document similarity
# With this result we set links between all the fouded documents
# Then the list of founded document and their path is set as metadata in the main document (pass as argument)

docID = sys.argv[1]
threshold = sys.argv[2]

# VARS
ES = "http://localhost:8080"
URL =  ES + "/Esprit/public/Interface/rpc"
USERNAME = "admin"
PASSWORD = "admin"

def esLogin():
    JSON = {"id":"1","method":"admin.login"}
    rLogin = requests.post( url=URL, json=JSON, auth=(USERNAME,PASSWORD) ) 
    cookies = rLogin.cookies
    cc = cookies.get_dict()
    return cc

def esLogout(cookie):
    JSON = {"id":"1","method":"admin.logout"}
    rLogout = requests.post( url=URL, json=JSON, cookies=cookie ) 
    print(rLogout.content)

def sendCall(JSON,cookie):
    rSendCall = requests.post(url = URL, json= JSON, cookies=cookie) 
    callData = rSendCall.json()
    print(callData)
    return callData[0]['result']

cookie = esLogin()

FINDSIMILAR = [ #getListOfSimilarDocuments
    {
    "method": "production.search",
    "id": "2",
    "params": {
        "query":"*",
        "similarityQuery": {
            "documentReferenceID":docID,
            "threshold":threshold
        }
     }
    }
]

getSimilarDocs = sendCall(FINDSIMILAR,cookie)
similarDocs = getSimilarDocs['objectList']
print(similarDocs)
similarDocMeta = ""
similarFound = False
for doc in similarDocs:
    if doc['ID'] != docID:
        similarFound = True
        GETDOCINFO = [ #getListOfSimilarDocuments
            {
            "method": "production.executeSQL",
            "id": "2",
            "params":{
                "sql": "select d.creationDate,d.NFSAccess, d.URLAccess from document d where d.ID='"+doc['ID']+"'"
            }
            }
        ]
        getDocInfo = sendCall(GETDOCINFO,cookie)
        if len(getDocInfo['objectList']) > 0:    
            docInfo = getDocInfo['objectList'][0]
            creationDate = docInfo[0]
            print(creationDate)
            volumeName = docInfo[2].split('/')[9]
            path = docInfo[1].split('/',1)
            docPath = "/" + volumeName +"/"+path[1]
            print(docPath)
            esPath = docPath.rsplit('/',1)[0] + "/" +doc['name']
            SETRELATION = [
             {
                "method": "relation.add",
                "id": "1",
                "params": {
                    "sourceID": docID,
                    "targetID": doc['ID'],
                    "description": "similarDocument",
                    "type": "UserDefined"
                }
            }
            ]
            print(SETRELATION)
            setDocRelation = sendCall(SETRELATION,cookie)
            print(setDocRelation)
            similarDocMeta = similarDocMeta + " \n " + esPath + " \n " + creationDate +" \n "

if similarFound == True:
    SETMETADATA = [
        {
        "method":"document.edit",
        "params":{
            "ID":docID,
            "metadatas":[
                ["D0", "Doubles", "true"],
                ["D0", "ListOfDoubles", similarDocMeta]
            ]
        }
        }
    ]
    setMetadata = sendCall(SETMETADATA,cookie)
    print(SETMETADATA)
esLogout(cookie)
